//NameTag by DarkyBenji
--Feature inspired from v2, recreated for v1

--Thanks to Tyron for the Colorskin
local colLookup = {[SKINCOLOR_WHITE] = "\x80",	[SKINCOLOR_SILVER] = "\x80",	[SKINCOLOR_SLATE] = "\x80",		[SKINCOLOR_ULTRAVIOLET] = "\x81",	[SKINCOLOR_PURPLE] = "\x81",	[SKINCOLOR_FUCHSIA] = "\x81",		[SKINCOLOR_POPCORN] = "\x82",	[SKINCOLOR_QUARRY] = "\x82",	[SKINCOLOR_YELLOW] = "\x82",	[SKINCOLOR_MUSTARD] = "\x82",	[SKINCOLOR_CROCODILE] = "\x82",	[SKINCOLOR_OLIVE] = "\x82",		[SKINCOLOR_LIME] = "\x83",	[SKINCOLOR_HANDHELD] = "\x83",	[SKINCOLOR_MOSS] = "\x83",	[SKINCOLOR_CAMOUFLAGE] = "\x83",	[SKINCOLOR_ROBOHOOD] = "\x83",	[SKINCOLOR_MINT] = "\x83",	[SKINCOLOR_GREEN] = "\x83",	[SKINCOLOR_PINETREE] = "\x83",	[SKINCOLOR_ALGAE] = "\x83",	[SKINCOLOR_PLAGUE] = "\x83",	[SKINCOLOR_EMERALD] = "\x83",	[SKINCOLOR_SWAMP] = "\x83",	[SKINCOLOR_DREAM] = "\x83",		[SKINCOLOR_PERIWINKLE] = "\x84",	[SKINCOLOR_BLUE] = "\x84",	[SKINCOLOR_BLUEBERRY] = "\x84",	[SKINCOLOR_NOVA] = "\x84",		[SKINCOLOR_CINNAMON] = "\x85",	[SKINCOLOR_RUBY] = "\x85",	[SKINCOLOR_RASPBERRY] = "\x85",	[SKINCOLOR_CHERRY] = "\x85",	[SKINCOLOR_RED] = "\x85",	[SKINCOLOR_CRIMSON] = "\x85",	[SKINCOLOR_MAROON] = "\x85",	[SKINCOLOR_FLAME] = "\x85",	[SKINCOLOR_SCARLET] = "\x85",	[SKINCOLOR_KETCHUP] = "\x85",		[SKINCOLOR_GREY] = "\x86",	[SKINCOLOR_NICKEL] = "\x86",	[SKINCOLOR_BLACK] = "\x86",	[SKINCOLOR_SKUNK] = "\x86",	[SKINCOLOR_JET] = "\x86",		[SKINCOLOR_DAWN] = "\x87",	[SKINCOLOR_SUNSET] = "\x87",	[SKINCOLOR_CREAMSICLE] = "\x87",	[SKINCOLOR_ORANGE] = "\x87",	[SKINCOLOR_PUMPKIN] = "\x87",	[SKINCOLOR_ROSEWOOD] = "\x87",	[SKINCOLOR_BURGUNDY] = "\x87",	[SKINCOLOR_TANGERINE] = "\x87",		[SKINCOLOR_CARIBBEAN] = "\x88",	[SKINCOLOR_AZURE] = "\x88",	[SKINCOLOR_AQUA] = "\x88",	[SKINCOLOR_TEAL] = "\x88",	[SKINCOLOR_CYAN] = "\x88",	[SKINCOLOR_JAWZ] = "\x88",	[SKINCOLOR_CERULEAN] = "\x88",	[SKINCOLOR_NAVY] = "\x88",	[SKINCOLOR_SAPPHIRE] = "\x88",		[SKINCOLOR_PASTEL] = "\x89",	[SKINCOLOR_MOONSLAM] = "\x89",	[SKINCOLOR_DUSK] = "\x89",	[SKINCOLOR_TOXIC] = "\x89",	[SKINCOLOR_MAUVE] = "\x89",	[SKINCOLOR_LAVENDER] = "\x89",	[SKINCOLOR_BYZANTIUM] = "\x89",	[SKINCOLOR_POMEGRANATE] = "\x89",		[SKINCOLOR_GOLD] = "\x8A",	[SKINCOLOR_ROYAL] = "\x8A",	[SKINCOLOR_BRONZE] = "\x8A",	[SKINCOLOR_COPPER] = "\x8A",	[SKINCOLOR_THUNDER] = "\x8A",		[SKINCOLOR_ARTICHOKE] = "\x8B",	[SKINCOLOR_VOMIT] = "\x8B",	[SKINCOLOR_GARDEN] = "\x8B",	[SKINCOLOR_TEA] = "\x8B",	[SKINCOLOR_PISTACHIO] = "\x8B",		[SKINCOLOR_PIGEON] = "\x8C",	[SKINCOLOR_PLATINUM] = "\x8C",	[SKINCOLOR_STEEL] = "\x8C",		[SKINCOLOR_FAIRY] = "\x8D",	[SKINCOLOR_SALMON] = "\x8D",	[SKINCOLOR_PINK] = "\x8D",	[SKINCOLOR_ROSE] = "\x8D",	[SKINCOLOR_BRICK] = "\x8D",	[SKINCOLOR_LEMONADE] = "\x8D",	[SKINCOLOR_BUBBLEGUM] = "\x8D",	[SKINCOLOR_LILAC] = "\x8D",		[SKINCOLOR_SEPIA] = "\x8E",	[SKINCOLOR_BEIGE] = "\x8E",	[SKINCOLOR_WALNUT] = "\x8E",	[SKINCOLOR_BROWN] = "\x8E",	[SKINCOLOR_LEATHER] = "\x8E",	[SKINCOLOR_RUST] = "\x8E",	[SKINCOLOR_WRISTWATCH] = "\x8E",	[SKINCOLOR_PEACH] = "\x8F",	[SKINCOLOR_CARAMEL] = "\x8F",	[SKINCOLOR_CREAM] = "\x8F",}
local starttime = 9*TICRATE + (3*TICRATE/4)
local FRACUNIT = FRACUNIT
local INT16_MAX = INT16_MAX
local NAME_MAXDIST = 320*FRACUNIT

--------------------------------------------------------------------------------
//CVAR
--------------------------------------------------------------------------------
local nametagactive = CV_RegisterVar({
	name = "nametag",
	defaultvalue = "On",
	flags = CV_SHOWMODIF,
	possiblevalue = CV_OnOff
})

local nametagclan = CV_RegisterVar({
	name = "nametag_clan",
	defaultvalue = "On",
	flags = CV_SHOWMODIF,
	possiblevalue = CV_OnOff
})

local nametagicon = CV_RegisterVar({
	name = "nametag_icon",
	defaultvalue = "Off",
	flags = CV_SHOWMODIF,
	possiblevalue = CV_OnOff
})

local nametagstats = CV_RegisterVar({
	name = "nametag_stats",
	defaultvalue = "Restat",
	flags = CV_SHOWMODIF,
	possiblevalue = {Off = 0, Restat = 1, Always = 2}
})

local nametagdist = CV_RegisterVar({
	name = "nametag_dist",
	defaultvalue = "160",
	flags = CV_SHOWMODIF|CV_FLOAT,
	possiblevalue = {MIN = 0, MAX = NAME_MAXDIST}
})

local nametagcap = CV_RegisterVar({
	name = "nametag_cap",
	defaultvalue = "4",
	flags = CV_SHOWMODIF,
	possiblevalue = CV_Natural
})

local nametagsmall = CV_RegisterVar({
	name = "nametag_small",
	defaultvalue = "Off",
	flags = CV_SHOWMODIF,
	possiblevalue = CV_OnOff
})

local nametagadjust = CV_RegisterVar({
	name = "nametag_adjust",
	defaultvalue = "0",
	flags = CV_SHOWMODIF,
	possiblevalue = CV_Unsigned
})

local nametagdynamic = CV_RegisterVar({
	name = "nametag_dynamic",
	defaultvalue = "On",
	flags = CV_SHOWMODIF,
	possiblevalue = CV_OnOff
})

local nametagdebug = CV_RegisterVar({
	name = "nametag_debug",
	defaultvalue = "Off",
	flags = CV_NOSHOWHELP|CV_SHOWMODIF,
	possiblevalue = CV_OnOff
})

--------------------------------------------------------------------------------
//NetVar CVAR
--------------------------------------------------------------------------------
local nametagcolor = CV_RegisterVar({
	name = "nametag_color",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})

local nametagstar = CV_RegisterVar({
	name = "nametag_star",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})

local nametaghpmod = CV_RegisterVar({
	name = "nametag_hp",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})

--First, we set things up
local dTags = {}
local function CanIhidemyTag(p)
	if p.kartstuff[k_hyudorotimer] 
	or p.mo.flags2 & MF2_DONTDRAW
	then return true
	else
	return false
	end
end
local function CanIkillmyTag(p)
	if p.exiting 
	or p.playerstate == PST_DEAD 
	or p.mo.health == 0 
	or p.spectator 
	or p.elim_rejoinEnd //???
	then return true
	else
	return false
	end
end

addHook("ThinkFrame", function()
	for player in players.iterate do
		if not player.mo or not player.mo.valid continue end 
		
		if not player.mo.taginit then
			table.insert(dTags, {mo = player.mo, visual = true, extra = nil})
			player.mo.taginit = true
		end

		for i = #dTags,1,-1 do
			local nametag = dTags[i]
			if nametag.mo and nametag.mo.valid then
				if nametag.mo == player.mo then
					--Hide the Tag but do not remove it yet
					if CanIhidemyTag(player) then
						nametag.visual = false
					else
						nametag.visual = true
					end
					
					--Now you can remove it, there's no need to keep it
					if CanIkillmyTag(player) then
						dTags[i] = 01
						table.remove(dTags, i)
					end
					
					--Extra that appear above your nametag
					if leveltime > 1 and not nametag.extra then
						--HpMod
						if nametaghpmod.value and (hpmod and hpmod.running) then
							nametag.extra = "HPMOD"
							
						--StatTracker
						elseif (nametagstar.value and nametagstats.value >= 1) and CV_FindVar("st_enabled") then
							nametag.extra = "STATTRACKER"
											
						--ReStat
						elseif (nametagstats.value and player.HMRs) or nametagstats.value == 2 then
							nametag.extra = "RESTAT"
											
						--Scorekeeper
						elseif nametagstar.value and CV_FindVar("sk_hoursuntilreset") then
							nametag.extra = "SCOREKEEPER"
						end					
					end
				end
			else
				dTags[i] = 01
				table.remove(dTags, i)
			end
		end
	end
end)

--Shoutout to Lat for the ScreenCoords
--With alot of edit because of god damn no-green-screen, fov, and render bullshit
local function R_GetScreenCoordsforNames(v, p, c, mx, my, mz)
	local camx, camy, camz, camangle, camaiming
	if p.awayviewtics then
		camx = p.awayviewmobj.x
		camy = p.awayviewmobj.y
		camz = p.awayviewmobj.z
		camangle = p.awayviewmobj.angle
		camaiming = p.awayviewaiming
	elseif c.chase then
		camx = c.x
		camy = c.y
		camz = c.z
		camangle = c.angle
		camaiming = c.aiming
	else
		camx = p.mo.x
		camy = p.mo.y
		camz = p.viewz-30*FRACUNIT
		camangle = p.mo.angle
		camaiming = p.aiming
	end

	local x = camangle-R_PointToAngle2(camx, camy, mx, my)
	
	local distfact = cos(x)
	if not distfact then
		distfact = 1
	end
	
	local res = (v.width()*100)/(v.height()) --Did you know that all green res give 160 on result?
	local fovplz = ((CV_FindVar("fov").value)/FRACUNIT)*res/90 --90*160/90 = 160 huehuehue
	local resfov = (res*2)-fovplz --160*2 = 320-160 = 160 HuEHuEHuE
	local adjustres = 0 --extra adjust for no-green with fov90, because FUCK THIS GAMDKZHDLMJBMJBZJ3
	if (res == fovplz)
		if (res < 160) --Square resolution
			adjustres = 160-res
		elseif (res > 160) --Wide Resolution
			adjustres = res-160
		end
	end
	local finalset = (resfov)+(adjustres)+(nametagadjust.value)
	--tadaa, and we add the adjust command incase some resolution doesn't work
	
	local ssadj = 0 --Why 2p splitscreen have to be an Ass?
	if splitscreen == 1 then
		ssadj = 2*finalset/5
	end 
	
	if x > ANGLE_90 or x < ANGLE_270 then
		return -9, -9, 0
	else
		x = FixedMul(tan(x, true), (finalset-ssadj)<<FRACBITS)+160<<FRACBITS
	end

	local y = camz-mz
	y = FixedDiv(y, FixedMul(distfact, R_PointToDist2(camx, camy, mx, my)))
	y = (y*(finalset+ssadj))+(100<<FRACBITS)
	y = y+tan(camaiming, true)*(finalset+ssadj)

	local scale = FixedDiv(finalset*FRACUNIT, FixedMul(distfact, R_PointToDist2(camx, camy, mx, my)))

	return x, y, scale
end

-- of course, fickle's replay system kind of sucks so splitscreen there will need an ADDITIONAL HACK.
-- thank you fickle.
local splitplayers = {}
local function splitnum(p)
	for i = 1, #splitplayers do
		if splitplayers[i] == p
			return i-1
		end
	end
end

--And now the render
local function TagNames(v, player, camera)
	--you don't need nametag lua if you have a custom exe that do the job for you (but still, get the lua for the other players)
	if CV_FindVar("kartnametag") and CV_FindVar("kartnametag").value then return end
	--Yeah i'm not gonna bother with splitscreen
	if nametagactive.value and (player and player.mo and player.mo.valid) then
		splitplayers[#splitplayers+1] = player
		local tagnum = 0
		for i = #dTags,1,-1 do
			local nametag = dTags[i]
			if nametag.mo and nametag.mo.valid then
				local maxdist = min(nametagdist.value, NAME_MAXDIST)*10
				local thisdist = R_PointToDist2(nametag.mo.x, nametag.mo.y, player.mo.x, player.mo.y) //R_PointToDist(nametag.mo.x, nametag.mo.y)
				//print(maxdist, thisdist)

				local posz = nametag.mo.z + nametag.mo.height
				local basex,basey = R_GetScreenCoordsforNames(v, player, camera, nametag.mo.x, nametag.mo.y, posz)
				local baselimitx, baselimity = UINT8_MAX, UINT8_MAX

				-- ready splitscreen stuff
				local splitflags = 0
				if splitscreen == 1 then -- 2p
					basey = $/2
					baselimity = $/2
					if splitnum(player)
						splitflags = V_SPLITSCREEN|V_SNAPTOBOTTOM	
					end
				elseif splitscreen > 1 then -- 3p / 4p
					basex = $/2
					basey = $/2
					baselimitx = $/2
					baselimity = $/2
					if splitnum(player) == 1
						splitflags = V_HORZSCREEN
					elseif splitnum(player) == 2
						splitflags = V_SPLITSCREEN|V_SNAPTOBOTTOM
					elseif splitnum(player) == 3
						splitflags = V_SPLITSCREEN|V_HORZSCREEN|V_SNAPTOBOTTOM
					end
				end
				
				if encoremode then 
					if splitscreen > 1 then
						basex = 160<<FRACBITS - $
					else
						basex = 320<<FRACBITS - $
					end
				end
				
				local namex = (basex>>FRACBITS)
				local namey = (basey>>FRACBITS)
				
				local transtag = 0
				if nametagdynamic.value
					if (thisdist > (maxdist*9/10)) --90%
						transtag = V_80TRANS
					elseif (thisdist > (maxdist*4/5)) --80%
						transtag = V_60TRANS
					elseif (thisdist > (maxdist*7/10)) --70%
						transtag = V_40TRANS
					elseif (thisdist > (maxdist*3/5)) --60%
						transtag = V_20TRANS
					end
				else
					transtag = V_HUDTRANS
				end
				
				local iconx, ficonx = 0, 0
				if nametagicon.value then
					iconx = 16
					ficonx = iconx*FRACUNIT
					if nametagsmall.value or splitscreen > 1 then
						iconx, ficonx = $/2, $/2
					end
				end
			
				if (nametag.mo != player.mo and leveltime > starttime) --display Other Player tag, but first...
				or (nametag.mo == player.mo and (leveltime > 0 and leveltime < 130)) --Let's display your tag before the countdown
				or (nametagdebug.value) --Or Just display all of them because yay Debug
					if (thisdist < maxdist)
						if namex < baselimitx and namey < baselimity and tagnum < nametagcap.value --plz
							tagnum = $+1
							if nametag.visual
								--Line Pointing
								local nametagscale = FRACUNIT
								if nametagsmall.value or splitscreen > 1 then nametagscale = $/2 end
									
								--Line Under Name
								local weighttag = table.concat({nametag.mo.player.name}, " ")
								local linew = "NTLINE0"
								if weighttag.len(nametag.mo.player.name) > 18
									linew = "NTLINE6"
								elseif weighttag.len(nametag.mo.player.name) > 15
									linew = "NTLINE5"
								elseif weighttag.len(nametag.mo.player.name) > 12
									linew = "NTLINE4"
								elseif weighttag.len(nametag.mo.player.name) > 9
									linew = "NTLINE3"
								elseif weighttag.len(nametag.mo.player.name) > 6
									linew = "NTLINE2"
								elseif weighttag.len(nametag.mo.player.name) > 3
									linew = "NTLINE1"
								end
								
								v.drawScaled(basex, basey, nametagscale, v.cachePatch("NTLINEP"), splitflags|transtag, v.getColormap(-1, nametag.mo.color))
								v.drawScaled(basex+(6*nametagscale), basey, nametagscale, v.cachePatch(linew), splitflags|transtag, v.getColormap(-1, nametag.mo.color))
										
								--Icon
								if nametagicon.value 
									v.drawScaled(basex+(4*nametagscale), basey-(30*nametagscale), nametagscale, v.cachePatch(skins[nametag.mo.skin].facemmap), splitflags|transtag, v.getColormap(nametag.mo.skin, nametag.mo.color))
								end
								
								--Color Name
								local colorname = colLookup[((nametag.mo.player.skincolor) and nametag.mo.player.skincolor or SKINCOLOR_WHITE)] -- hi where's the uhh failsafe
								
								if (colorname == nil) then colorname = colLookup[1]; end
								if not nametagcolor.value then colorname = colLookup[1] end //just incase of custom build
								
								--Name Text and Clan
								local nametext = ""..colorname..""..(nametag.mo.player.name)..""
								if nametagclan.value and nametag.mo.player.HMclan
									nametext = "\x8C"..(nametag.mo.player.HMclan).." "..colorname..""..(nametag.mo.player.name)..""
								end	
								
								if nametagsmall.value or splitscreen > 1 then
									--Small Size
									v.drawString(iconx+namex+2, namey-13, nametext, splitflags|transtag|V_ALLOWLOWERCASE, "small")
									if nametag.extra then
										--HpMod
										if nametag.extra == "HPMOD" then
											v.drawString(iconx+namex+2, namey-18, "\x8D"..(nametag.mo.player.hpmod.hp).."%", splitflags|transtag, "small")
											
										--StatTracker
										elseif nametag.extra == "STATTRACKER" then					
											if nametag.mo.player.score >= 2500
												v.drawString(iconx+namex+2, namey-18, "\x80"..nametag.mo.player.score, splitflags|transtag, "small")
											elseif nametag.mo.player.score >= 2250
												v.drawString(iconx+namex+2, namey-18, "\x81"..nametag.mo.player.score, splitflags|transtag, "small")
											elseif nametag.mo.player.score >= 2000
												v.drawString(iconx+namex+2, namey-18, "\x84"..nametag.mo.player.score, splitflags|transtag, "small")
											elseif nametag.mo.player.score >= 1800
												v.drawString(iconx+namex+2, namey-18, "\x82"..nametag.mo.player.score, splitflags|transtag, "small")
											elseif nametag.mo.player.score >= 1600
												v.drawString(iconx+namex+2, namey-18, "\x86"..nametag.mo.player.score, splitflags|transtag, "small")
											elseif nametag.mo.player.score >= 1300
												v.drawString(iconx+namex+2, namey-18, "\x8D"..nametag.mo.player.score, splitflags|transtag, "small")
											else
												v.drawString(iconx+namex+2, namey-18, "\x83"..nametag.mo.player.score, splitflags|transtag, "small")
											end
											
										--ReStat
										elseif nametag.extra == "RESTAT" then
											v.drawString(iconx+namex+2, namey-18, "\x88s"..(nametag.mo.player.kartspeed).."", splitflags|transtag, "small")
											v.drawString(iconx+namex+12, namey-18, "\x87w"..(nametag.mo.player.kartweight).."", splitflags|transtag, "small")
											
										--Scorekeeper	
										elseif nametag.extra == "SCOREKEEPER" then
											if nametag.mo.player.score >= 100000
												v.drawString(iconx+namex+2, namey-18, "\x82************", splitflags|transtag, "small")
											elseif nametag.mo.player.score >= 90000
												v.drawString(iconx+namex+2, namey-18, "\x82***********", splitflags|transtag, "small")
											elseif nametag.mo.player.score >= 80000
												v.drawString(iconx+namex+2, namey-18, "\x82**********", splitflags|transtag, "small")
											elseif nametag.mo.player.score >= 70000
												v.drawString(iconx+namex+2, namey-18, "\x82*********", splitflags|transtag, "small")
											elseif nametag.mo.player.score >= 60000 
												v.drawString(iconx+namex+2, namey-18, "\x82********", splitflags|transtag, "small")
											elseif nametag.mo.player.score >= 50000
												v.drawString(iconx+namex+2, namey-18, "\x82*******", splitflags|transtag, "small")
											elseif nametag.mo.player.score >= 40000 
												v.drawString(iconx+namex+2, namey-18, "\x82******", splitflags|transtag, "small")
											elseif nametag.mo.player.score >= 30000
												v.drawString(iconx+namex+2, namey-18, "\x82*****", splitflags|transtag, "small")
											elseif nametag.mo.player.score >= 20000 
												v.drawString(iconx+namex+2, namey-18, "\x82****", splitflags|transtag, "small")
											elseif nametag.mo.player.score >= 10000 
												v.drawString(iconx+namex+2, namey-18, "\x82***", splitflags|transtag, "small")
											elseif nametag.mo.player.score >= 5000 
												v.drawString(iconx+namex+2, namey-18, "\x82**", splitflags|transtag, "small")
											elseif nametag.mo.player.score >= 1000 
												v.drawString(iconx+namex+2, namey-18, "\x82*", splitflags|transtag, "small")
											end
										end
									end
								else
									--Normal Size
									v.drawString(iconx+namex+4, namey-26, nametext, splitflags|transtag|V_ALLOWLOWERCASE, "thin")
									if nametag.extra then
										--HpMod
										if nametag.extra == "HPMOD" then
											v.draw(iconx+namex+4, namey-36, v.cachePatch("NTHP"), splitflags|transtag)
											v.drawString(iconx+namex+14, namey-35, "\x8D"..(nametag.mo.player.hpmod.hp).."", splitflags|transtag, "left")
											
										--StatTracker
										elseif nametag.extra == "STATTRACKER" then					
											if nametag.mo.player.score >= 2500
												v.drawString(iconx+namex+4, namey-35, "\x80"..nametag.mo.player.score, splitflags|transtag, "left")
											elseif nametag.mo.player.score >= 2250
												v.drawString(iconx+namex+4, namey-35, "\x81"..nametag.mo.player.score, splitflags|transtag, "left")
											elseif nametag.mo.player.score >= 2000
												v.drawString(iconx+namex+4, namey-35, "\x84"..nametag.mo.player.score, splitflags|transtag, "left")
											elseif nametag.mo.player.score >= 1800
												v.drawString(iconx+namex+4, namey-35, "\x82"..nametag.mo.player.score, splitflags|transtag, "left")
											elseif nametag.mo.player.score >= 1600
												v.drawString(iconx+namex+4, namey-35, "\x86"..nametag.mo.player.score, splitflags|transtag, "left")
											elseif nametag.mo.player.score >= 1300
												v.drawString(iconx+namex+4, namey-35, "\x8D"..nametag.mo.player.score, splitflags|transtag, "left")
											else
												v.drawString(iconx+namex+4, namey-35, "\x83"..nametag.mo.player.score, splitflags|transtag, "left")
											end
											
										--ReStat
										elseif nametag.extra == "RESTAT" then
											v.draw(iconx+namex+4, namey-36, v.cachePatch("NTSP"), splitflags|transtag)
											v.drawString(iconx+namex+13, namey-35, "\x88"..(nametag.mo.player.kartspeed).."", splitflags|transtag, "left")
											v.draw(iconx+namex+24, namey-36, v.cachePatch("NTWH"), splitflags|transtag)
											v.drawString(iconx+namex+33, namey-35, "\x87"..(nametag.mo.player.kartweight).."", splitflags|transtag, "left")
											
										--Scorekeeper
										elseif nametag.extra == "SCOREKEEPER" then
											if nametag.mo.player.score >= 100000
												v.draw(iconx+namex+4, namey-35, v.cachePatch("NTCRWN"), splitflags|transtag)
												v.draw(iconx+namex+20, namey-35, v.cachePatch("NTCRWN"), splitflags|transtag)
												v.draw(iconx+namex+36, namey-35, v.cachePatch("NTCRWN"), splitflags|transtag)
											elseif nametag.mo.player.score >= 90000 
												v.draw(iconx+namex+4, namey-35, v.cachePatch("NTCRWN"), splitflags|transtag)
												v.draw(iconx+namex+20, namey-35, v.cachePatch("NTCRWN"), splitflags|transtag)
												v.drawString(iconx+namex+36, namey-35, "\x82***", splitflags|transtag, "left")
											elseif nametag.mo.player.score >= 80000 
												v.draw(iconx+namex+4, namey-35, v.cachePatch("NTCRWN"), splitflags|transtag)
												v.draw(iconx+namex+20, namey-35, v.cachePatch("NTCRWN"), splitflags|transtag)
												v.drawString(iconx+namex+36, namey-35, "\x82**", splitflags|transtag, "left")
											elseif nametag.mo.player.score >= 70000 
												v.draw(iconx+namex+4, namey-35, v.cachePatch("NTCRWN"), splitflags|transtag)
												v.draw(iconx+namex+20, namey-35, v.cachePatch("NTCRWN"), splitflags|transtag)
												v.drawString(iconx+namex+36, namey-35, "\x82*", splitflags|transtag, "left")
											elseif nametag.mo.player.score >= 60000 
												v.draw(iconx+namex+4, namey-35, v.cachePatch("NTCRWN"), splitflags|transtag)
												v.draw(iconx+namex+20, namey-35, v.cachePatch("NTCRWN"), splitflags|transtag)
											elseif nametag.mo.player.score >= 50000 
												v.draw(iconx+namex+4, namey-35, v.cachePatch("NTCRWN"), splitflags|transtag)
												v.drawString(iconx+namex+20, namey-35, "\x82***", splitflags|transtag, "left")
											elseif nametag.mo.player.score >= 40000
												v.draw(iconx+namex+4, namey-35, v.cachePatch("NTCRWN"), splitflags|transtag)
												v.drawString(iconx+namex+20, namey-35, "\x82**", splitflags|transtag, "left")
											elseif nametag.mo.player.score >= 30000 
												v.draw(iconx+namex+4, namey-35, v.cachePatch("NTCRWN"), splitflags|transtag)
												v.drawString(iconx+namex+20, namey-35, "\x82*", splitflags|transtag, "left")
											elseif nametag.mo.player.score >= 20000 
												v.draw(iconx+namex+4, namey-35, v.cachePatch("NTCRWN"), splitflags|transtag)
											elseif nametag.mo.player.score >= 10000 
												v.drawString(iconx+namex+4, namey-35, "\x82***", splitflags|transtag, "left")
											elseif nametag.mo.player.score >= 5000 
												v.drawString(iconx+namex+4, namey-35, "\x82**", splitflags|transtag, "left")
											elseif nametag.mo.player.score >= 1000 
												v.drawString(iconx+namex+4, namey-35, "\x82*", splitflags|transtag, "left")
											end
										end
									end
								end
							end
						end
					end
				end
			end
		end
		if nametagdebug.value
			v.drawString(12,125, "Nametag Show: "..tagnum.."/"..nametagcap.value.."",V_ALLOWLOWERCASE|V_SNAPTOLEFT,"thin")
		end
	end
		
	-- flush table
	if #splitplayers > splitscreen
		splitplayers = {}
	end
end
hud.add(TagNames)